Public Class Form1

    Private Sub txtTest_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtTest.Resize
        CheckScrollBars(txtTest)
    End Sub
    Private Sub txtTest_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtTest.TextChanged
        CheckScrollBars(txtTest)
    End Sub

    ' See if the TextBox needs a vertical scroll bar.
    Private Sub CheckScrollBars(ByVal txt As TextBox)
        ' Make a Graphics object for the TextBox.
        Dim gr As Graphics
        gr = txt.CreateGraphics()

        ' Make a layout rectangle.
        Dim layout_area As New SizeF(txt.ClientSize.Width, txt.ClientSize.Height)
        Using sf As New StringFormat()
            Dim chars_fitted, lines_filled As Integer
            gr.MeasureString(txt.Text, txt.Font, layout_area, sf, chars_fitted, lines_filled)

            ' See if all characters fitted.
            If chars_fitted < txt.Text.Length Then
                txt.ScrollBars = ScrollBars.Vertical
            Else
                txt.ScrollBars = ScrollBars.None
            End If
        End Using
    End Sub
End Class
